/*
    Data structures & Algorithms
    Copyright 2004, 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __BOX_H
#define __BOX_H

class Box {
private:
public:
	GLfloat color[4];
	GLfloat pos[3];
	GLfloat size[3];
	Box();
	Box(GLfloat c1, GLfloat c2, GLfloat c3, GLfloat c4, GLfloat p1, GLfloat p2, GLfloat p3, GLfloat s1, GLfloat s2, GLfloat s3) {
		color[0] = c1;
		color[1] = c2;
		color[2] = c3;
		color[3] = c4;
		pos[0] = p1;
		pos[1] = p2;
		pos[2] = p3;
		size[0] = s1;
		size[1] = s2;
		size[2] = s3;
	}
};

#include <vector>

using std::vector;

void drawBox(const Box &b, bool begin);
void drawBox(GLfloat c0, GLfloat c1, GLfloat c2, GLfloat p0, GLfloat p1, GLfloat p2, GLfloat s0, GLfloat s1, GLfloat s2, bool begin = true);
void drawBoxes(const vector<Box> &boxes);



#endif
