/*
    Cothread
    Copyright 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __COTHREAD_H
#define __COTHREAD_H

#ifdef __GNUC__
#  if (defined(__i386__) && (defined(linux) || defined(WIN32) || defined(__APPLE__))) || ((defined(__ppc__) || defined(__powerpc__)) && (defined(__APPLE__) || defined(linux)))
#    ifndef COTHREAD_NOASM
#      define COTHREAD_ASM_SUPPORTED
#    endif
#  endif
#endif

typedef int (*cothread_func)(void* arg);

struct _cothread;
typedef struct _cothread* cothread;

#ifdef __cplusplus
extern "C" {
#endif

cothread cothread_create(cothread_func func, void* arg);
void cothread_swap(cothread thread);
int cothread_join(cothread thread);
int cothread_running(cothread thread);
int cothread_active(cothread thread);

#ifdef __cplusplus
}
#endif

#endif

