/*
    Data structures & Algorithms
    Copyright 2004, 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __FPS_H
#define __FPS_H

namespace LCDDisplay {
	void precalc();
	void draw(float x, float y, float h, float wh, float skew, const char *str, float r = 0, float g = 1, float b = 0, int width = 0, int height = 0);
	void setMotionBlur(bool b);
}

class FPSCounter {
private:
	int totframes;
	int curframes, curtime;
	int update;
	int lasttime, lastframes;
	float r, g, b;
public:
	FPSCounter(int u);
	~FPSCounter();
	void count(int time);
	void draw(int width = 0, int height = 0); // real screen size
	void setColor(float r, float b, float g);
};


#endif
