/*
    Data structures & Algorithms
    Copyright 2004, 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __GRAPHANIM_H
#define __GRAPHANIM_H

#include <vector>

using std::vector;


#include "algorithms.h" // for Anim

class Graph;
class GraphAnimItem;

class GraphAnim : public Anim {
private:
	vector<GraphAnimItem> anims;
	bool updateAnim(GraphAnimItem &a);

	void zoomHighlight(int type, int start, int end);
public:
	GraphAnim(Graph *g);
	~GraphAnim();

	void drawAnim(int msec = 0);
	bool updateAnims();
	void clearAnims();
	AnimType getType() { return GRAPH; }
	void draw(int time, int difftime);



	Graph *graph;
	void markRed(int n);
	void markGreen(int n);
	void clearMark(int n);
	void clearMarks();
	void animSwap(int a, int b, bool doswap = true);
	void highlight(int start, int end);
	void clearHighlight();
	void zoom(int start, int end);
	void clearZoom();
	void moveForward(int n);
	void slideRight(int n, bool docopy = true);
	void moveTo(int n, int n2, bool docopy = true);
	void moveBackTo(int n, int n2);
	void swapNeighbors(int n);
};



#endif
