#!/bin/sh

NAME="Data structures & Algorithms"
APP="Dst.app"
BIN="dst"
DMG="$1"
shift 1

rm -rf "$NAME" || exit 1
mkdir -p "$NAME" || exit 1
cd "$NAME" || exit 1
cp -R ../$APP . || exit 1
find $APP -name CVS -type d | xargs rm -rf
strip $APP/Contents/MacOS/$BIN || exit 1
mkdir -p $APP/Contents/Frameworks || exit 1

cp -R ~/sdlmain/SDL.framework $APP/Contents/Frameworks || exit 1
cp -R ~/sdlmain/SDL_ttf.framework $APP/Contents/Frameworks || exit 1

cp ../COPYING COPYING.txt
cp ../COPYING.BITSTREAM COPYING-BITSTREAM.txt
iconv -f latin1 -t macroman ../README > README.txt
cp ../README-SDL.txt .

mv $APP "$NAME.app" || exit 1
cd .. || exit 1
rm -f $DMG || exit 1
hdiutil create -srcfolder "$NAME" tmp.dmg || exit 1
hdiutil convert -format UDZO -imagekey zlib-level=9 tmp.dmg -o $DMG || exit 1
rm -f tmp.dmg || exit 1
rm -rf "$NAME" || exit 1

