/*
    Data structures & Algorithms
    Copyright 2004, 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __MATRIX_H
#define __MATRIX_H

#include <SDL_opengl.h>

void Matrix_invertf(GLfloat *out, const GLfloat *in);
void Matrix_gaussInvertf(GLfloat *out, const GLfloat *in);
void Matrix_gaussJordanf(GLfloat *out, const GLfloat *in);
void Matrix_fakeInvertf(GLfloat *out, const GLfloat *in);

void Matrix_multf(GLfloat *out, const GLfloat *m1, const GLfloat *m2);
void Matrix_multVect4f(GLfloat *out, const GLfloat *matrix, const GLfloat *vect);
void Matrix_multVect3f(GLfloat *out, const GLfloat *matrix, const GLfloat *vect, GLfloat w = 1);

#endif
