/*
    Data structures & Algorithms
    Copyright 2004, 2005 Martin Storsj

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Martin Storsj
    martin@martin.st
*/

#ifndef __SPHERE_H
#define __SPHERE_H

class Sphere {
private:
	GLfloat *points;
	int n, m;
	void makeRing(float pos, GLfloat *ring);
	void makeArc(float pos, GLfloat *arc);
	void drawRing(float radius, GLfloat *ring1, GLfloat *ring2);
	void drawArc(float radius, GLfloat *arc1, int pitch1, GLfloat *arc2, int pitch2);
public:
	Sphere(int n = 20, int m = 15);
	~Sphere();
	void draw(float radius, float start = 0, float end = 1);
	void drawSector(float radius, float start = 0, float end = 1);
};



#endif
